import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

class RationalTest extends JFrame implements ActionListener, CaretListener
{
	private JTextField txtNumerator1;
	private JTextField txtDenominator1;
	
	private JTextField txtNumerator2;
	private JTextField txtDenominator2;

	private JLabel lblResult;
	private JLabel lblForwardSlash1;
	private JLabel lblForwardSlash2;

	private JButton btnAdd;
	private JButton btnSubtract;
	private JButton btnMultiply;
	private JButton btnDivide;
	
	
	public RationalTest() 
	{

		addWindowListener(
			new WindowAdapter() 
			{
				public void windowClosing(WindowEvent e) 
				{
					dispose();
					System.exit(0);
				}
			});
			
		Container c = getContentPane();
		

		c.setLayout(new FlowLayout());
	
		txtNumerator1 = new JTextField(15);
		txtDenominator1 = new JTextField(15);
		

		txtNumerator2 = new JTextField(15);
		txtDenominator2 = new JTextField(15);

	
		lblForwardSlash1 = new JLabel("/");
		lblForwardSlash2 = new JLabel("/");
		
		txtDenominator1.addCaretListener(this);
		txtDenominator2.addCaretListener(this);
		
		c.add(txtNumerator1);
		c.add(lblForwardSlash1);
		c.add(txtDenominator1);
		
		c.add(txtNumerator2);
		c.add(lblForwardSlash2);
		c.add(txtDenominator2);
	
		
		btnAdd = new JButton("Add");
		btnSubtract = new JButton("Subtract");
		btnMultiply = new JButton("Multiply");
		btnDivide = new JButton("Divide");

		btnAdd.addActionListener(this);
		btnSubtract.addActionListener(this);
		btnMultiply.addActionListener(this);
		btnDivide.addActionListener(this);

		btnAdd.setEnabled(false);
		btnSubtract.setEnabled(false);
		btnMultiply.setEnabled(false);
		btnDivide.setEnabled(false);

		c.add(btnAdd);
		c.add(btnSubtract);
		c.add(btnMultiply);
		c.add(btnDivide);

		lblResult = new JLabel("                               ");
		c.add(lblResult);

	}
	
	public void actionPerformed(ActionEvent e)
	{
		Rational rational1;
		Rational rational2;
		
		try
		{
			int Numerator1 = Integer.parseInt(txtNumerator1.getText());
			int Denominator1 = Integer.parseInt(txtDenominator1.getText());
			
			int Numerator2 = Integer.parseInt(txtNumerator2.getText());
			int Denominator2 = Integer.parseInt(txtDenominator2.getText());
	
			rational1 = new Rational(Numerator1, Denominator1);
			rational2 = new Rational(Numerator2,Denominator2 );
			
			if (e.getSource() == btnAdd)
			{
				rational1.Add(rational2);
				lblResult.setText(rational1.toString());			
			}
			else if (e.getSource() == btnSubtract)
			{
				rational1.Subtract(rational2);
				lblResult.setText(rational1.toString());			
			}
			else if (e.getSource() == btnMultiply)
			{
				rational1.Multiply(rational2);
				lblResult.setText(rational1.toString());			
			}
			else if (e.getSource() == btnDivide)
			{
				rational1.Divide(rational2);
				lblResult.setText(rational1.toString());			
			}		
		}
		catch(Exception exception)
		{
			lblResult.setText("Not numberic");						
		}
	}

	public void caretUpdate(CaretEvent e)  
	{
		boolean EnableButtons = false;
		
		
		try
		{
			int Denominator1 = Integer.parseInt(txtDenominator1.getText());
		 	int Denominator2 = Integer.parseInt(txtDenominator2.getText());
		 
	
			if(Denominator1 != 0 && Denominator2 != 0)
			{
				EnableButtons = true;
			}	
		}
		catch(Exception exception)
		{
			EnableButtons = false;
		}
		
		btnAdd.setEnabled(EnableButtons);
		btnSubtract.setEnabled(EnableButtons);
		btnMultiply.setEnabled(EnableButtons);
		btnDivide.setEnabled(EnableButtons);
				
	}

	public static void main(String args[]) {
		System.out.println("Starting Rational Test...");
		RationalTest mainFrame = new RationalTest();
		mainFrame.setSize(400, 400);
		mainFrame.setTitle("Rational Test");
		mainFrame.setVisible(true);
	}
}